datablock ItemData(DrumsItem) {
  category = "Weapon";
  className = "Weapon";

  shapeFile = "./models/drums_item.dts";
  emap = true;

  uiName = "Drum Machine";
  iconName = "./icon_drums";

  image = DrumsImage;
  canDrop = true;

  doColorShift = false;
  colorShiftColor = "0.5 0.5 0.5 1";

  friction = 0.599218;
};

datablock ShapeBaseImageData(DrumsImage) {
  className = "WeaponImage";
  shapeFile = "./models/drums_image.dts";
  item = DrumsItem;
  emap = true;

  mountPoint = 0;

  offset = "0.2 0.2 -0.1";
  eyeOffset = "0 0.6 -2.3";

  // This is used by the instruments mod to determine what sounds to use
  // It's also used to check if an image is even an instrument to begin with
  instrumentType = "Drums";

  doColorShift = true;
  colorShiftColor = DrumsItem.colorShiftColor;

  stateName[0]                     = "Activate";
  stateTimeoutValue[0]             = 0.15;
  stateTransitionOnTimeout[0]       = "Ready";
  stateSound[0]          = weaponSwitchSound;

  stateName[1]                     = "Ready";
  stateTransitionOnTriggerDown[1]  = "Play";
  stateAllowImageChange[1]         = true;
  stateSequence[1]  = "Ready";

  stateName[2]                    = "Play";
  stateTransitionOnTimeout[2]     = "PostPlay";
  stateTimeoutValue[2]            = 0.14;
  stateFire[2]                    = true;
  stateAllowImageChange[2]        = false;
  stateScript[2]                  = "onPlay";
  stateWaitForTimeout[2]      = true;
  stateEmitterTime[2]        = 0.05;

  stateName[3] = "PostPlay";
  stateEmitterTime[3]        = 0.05;
  stateEmitterNode[3]        = "muzzleNode";
  stateTimeoutValue[3]            = 0.01;
  stateTransitionOnTimeout[3]     = "Reload";

  stateName[4]      = "Reload";
  stateSequence[4]                = "Reload";
  stateTransitionOnTriggerUp[4]     = "Ready";
  stateSequence[4]  = "Ready";
};

// ------------------------------------------------------------------------------

function DrumsImage::onMount(%this, %obj, %slot) {
  Parent::onMount(%this, %obj, %slot);

  %obj.playThread(2, armReadyBoth);
  
  %obj.hideNode("RHand");
  %obj.hideNode("RHook");
  %obj.hideNode("LHand");
  %obj.hideNode("LHook");
}

function DrumsImage::onUnmount(%this, %obj, %slot) {
  Parent::onUnmount(%this, %obj, %slot);

  %obj.playThread(2, root);

  if (isObject(%obj.client)) {
    %obj.client.applyBodyParts();
    %obj.client.applyBodyColors();
  }
  else {
    applyDefaultCharacterPrefs(%obj);
  }
}

// ------------------------------------------------------------------------------

function DrumsImage::onPlay(%this, %obj, %pos) {
  // callback
}


// ------------------------------------------------------------------------------

/////////////////
// Drum Sticks //
/////////////////

datablock ItemData(DrumSticksItem) {
  category = "Weapon";
  className = "Weapon";

  shapeFile = "./models/drumSticks_item.dts";
  emap = true;

  uiName = "Drum Sticks";
  iconName = "./icon_drumSticks";

  image = DrumSticksImage;
  canDrop = true;

  doColorShift = true;
  colorShiftColor = "0.85 0.77 0.60 1.00";

  friction = 0.599218;
};

datablock ShapeBaseImageData(DrumSticksImage) {
  className = "WeaponImage";
  shapeFile = "./models/drumSticks_image.dts";
  item = DrumSticksItem;
  emap = true;

  mountPoint = 0;

  offset = "-0.525 0.05 0";
  eyeOffset = "0 1 -0.75";

  // This is used by the instruments mod to determine what sounds to use
  // It's also used to check if an image is even an instrument to begin with
  instrumentType = "Drums";

  doColorShift = true;
  colorShiftColor = DrumSticksItem.colorShiftColor;

  stateName[0]                     = "Activate";
  stateTimeoutValue[0]             = 0.15;
  stateTransitionOnTimeout[0]       = "Ready";
  stateSound[0]          = weaponSwitchSound;

  stateName[1]                     = "Ready";
  stateTransitionOnTriggerDown[1]  = "Play";
  stateAllowImageChange[1]         = true;
  stateSequence[1]  = "Ready";

  stateName[2]                    = "Play";
  stateTransitionOnTimeout[2]     = "PostPlay";
  stateTimeoutValue[2]            = 0.14;
  stateFire[2]                    = true;
  stateAllowImageChange[2]        = false;
  stateScript[2]                  = "onPlay";
  stateWaitForTimeout[2]      = true;
  stateEmitterTime[2]        = 0.05;

  stateName[3] = "PostPlay";
  stateEmitterTime[3]        = 0.05;
  stateEmitterNode[3]        = "muzzleNode";
  stateTimeoutValue[3]            = 0.01;
  stateTransitionOnTimeout[3]     = "Reload";

  stateName[4]      = "Reload";
  stateSequence[4]                = "Reload";
  stateTransitionOnTriggerUp[4]     = "Ready";
  stateSequence[4]  = "Ready";
};

// ------------------------------------------------------------------------------

function DrumSticksImage::onMount(%this, %obj, %slot) {
  Parent::onMount(%this, %obj, %slot);
  %obj.playThread(2, armReadyBoth);
}

function DrumSticksImage::onUnmount(%this, %obj, %slot) {
  Parent::onUnmount(%this, %obj, %slot);

  %obj.playThread(2, root);

  if (isObject(%obj.client)) {
    %obj.client.applyBodyParts();
    %obj.client.applyBodyColors();
  }
  else {
    applyDefaultCharacterPrefs(%obj);
  }
}

// ------------------------------------------------------------------------------

function DrumSticksImage::onPlay(%this, %obj, %pos) {
  // callback
}
